#pragma once

namespace DeeJay
{
    class AudioFilePlayer : public IXAudio2VoiceCallback
    {
    private:
        IXAudio2SourceVoice * pSourceVoice;
        AudioSample * pAudioBuffer;
        int audioBufferLength;
        double audioBufferIndex;

        double speedRatio;
        int samplesPerSecond;

        int playerBufferLength;
        AudioSample * playerBuffer1;
        AudioSample * playerBuffer2;

    public:
        AudioFilePlayer(IXAudio2* pXAudio2, LoadedAudioFileInfo loadedAudioFileInfo);
        ~AudioFilePlayer();

        void SetSpeedRatio(double speedRatio);
        void SetPositionFraction(double fraction);
        double GetSecondsElapsed();

    private:
        void SubmitBuffer(AudioSample * pSampleBuffer, int sampleBufferLength);
        AudioSample InterpolateSamples();

        // Callbacks required for IXAudio2VoiceCallback
        void _stdcall OnVoiceProcessingPassStart(UINT32 bytesRequired){}
        void _stdcall OnVoiceProcessingPassEnd(){}
        void _stdcall OnStreamEnd(){}
        void _stdcall OnBufferStart(void* pContext){}
        void _stdcall OnBufferEnd(void* pContext);
        void _stdcall OnLoopEnd(void*){}
        void _stdcall OnVoiceError(void*, HRESULT){}
    };
}

