#pragma once

namespace StreamMusicFile
{
    class AudioFilePlayer : public IXAudio2VoiceCallback
    {
    private:
        Microsoft::WRL::ComPtr<IMFSourceReader> mfSourceReader;
        IXAudio2SourceVoice* pSourceVoice;
        bool endOfFile;

    public:
        AudioFilePlayer(Microsoft::WRL::ComPtr<IXAudio2> pXAudio2, Microsoft::WRL::ComPtr<IMFSourceReader> pMFSourceReader);

    private:
        void SubmitBuffer();
        byte * GetNextBlock(int * pAudioBufferLength);

        // Callbacks required for IXAudio2VoiceCallback
        void _stdcall OnVoiceProcessingPassStart(UINT32 bytesRequired){}
        void _stdcall OnVoiceProcessingPassEnd(){}
        void _stdcall OnStreamEnd(){}
        void _stdcall OnBufferStart(void* pContext){}
        void _stdcall OnBufferEnd(void* pContext);
        void _stdcall OnLoopEnd(void*){}
        void _stdcall OnVoiceError(void*, HRESULT){}
    };
}

